<?php
/*****************************************************************************
 * ID   : $Id: master_tb.php,v 1.2 2007/08/18 08:17:31 secondarykey Exp $
 * Name : マスタテーブル操作
 * Specifications :　マスタテーブルの操作を行う
 ****************************************************************************/
  class master_tb extends tables { 
 
 	/**
	 * 基底クラス使用変数
	 */
	var $myTableName        = "master_tb"; 
	var $myColumnName       = "id,name,detail";
	var $myInsertColumnName = "name,detail";
	var $myOrgWhere         = "id";
	var $myOrderBy          = "id";
	
	/**
	 * メンバ変数
	 **/	
 	var $myID;
	var $myName;	
	var $myDetail;	
  
	/**
	 * 表挿入用のデータ
	 */
	function getInsertValue() {
		return "'" . $this->myName . "'," .
		        "'" . $this->myDetail  . "'";
	}	
	
	/**
	 * 更新用のデータ
	 */
	function getUpdateValue() {
		return " name = '" . $this->myName . "'," .
		        " detail = '"  . $this->myDetail  . "' ";
	}	

	/**
	 * オブジェクト生成
	 */
	function createObject($aRow) {
		$obj = new 	master_tb();
		$obj->setID($aRow->id);
		$obj->setName($aRow->name);
		$obj->setDetail($aRow->detail);
		return $obj;
	}	

	/**
	 * マスタの名称一覧を設定	
	 */
	function getSelection($aID,$aName = "master_id") {
		//戻り値に名称を設定
		$rtn = '<select name="' . $aName . '">';

		$master_tb = new master_tb;
		//テンプレートを全件取得
		$mst_array = $master_tb->select();
		
		if ( $mst_array != null ) {
			//テンプレート数回繰り返す	
			foreach ($mst_array as $elm) {
				$id   = $elm->getID();	
				$name = $elm->getName();	
				$selected = "";
				//同一IDだった場合
				if ($id == $aID ) {
					//選択対象にする
					$selected = " selected";
				}
				//データを作成
				$opt_val = '<option value="' . $id . '"' . $selected . '>' . $name . '</option>';
				//一覧に追加
				$rtn = $rtn . $opt_val;
			}
		}
		//タグを閉じる
		$rtn = $rtn . '</select>';
		return $rtn;
	}
	
  	function getID() {
		return $this->myID;
	}

	function getName() {
		return $this->myName;
	}
	
	function getDetail() {
		return $this->myDetail;
	}
	
	function setID($aID) {
		$this->myID = $aID;
	}

	function setName($aName) {
		$this->myName = $aName;
	}
	
	function setDetail($aDetail) {
		$this->myDetail = $aDetail;
	}
  } 
?>
