<?php
/*****************************************************************************
 * ID   : $Id: masterdata_tb.php,v 1.1 2007/03/16 14:05:52 secondarykey Exp $
 * Name : 
 * Specifications :
 ****************************************************************************/
  class masterdata_tb extends tables { 
 
 	/**
	 * 基底クラス使用変数
	 */
	var $myTableName        = "masterdata_tb"; 
	var $myColumnName       = "id,master_id,name,detail";
	var $myInsertColumnName = "master_id,name,detail";
	var $myOrgWhere         = "id";
	var $myOrderBy          = "id,master_id";
	
	/**
	 * メンバ変数
	 **/	
 	var $myID;
 	var $myMasterID;
	var $myName;
	var $myDetail;	
  
	/**
	 * 表挿入用のデータ
	 */
	function getInsertValue() {
		return $this->myMasterID . "," .
				"'" . $this->myName . "'," .
		        "'" . $this->myDetail  . "'";
	}	
	
	/**
	 * 更新用のデータ
	 */
	function getUpdateValue() {
		return " name = '" . $this->myName . "'," .
		        " detail = '"  . $this->myDetail  . "' ";
	}	

	/**
	 * オブジェクト生成
	 */
	function createObject($aRow) {
		$obj = new 	masterdata_tb();
		$obj->setID($aRow->id);
		$obj->setMasterID($aRow->master_id);
		$obj->setName($aRow->name);
		$obj->setDetail($aRow->detail);
		return $obj;
	}
	
  	/**
  	 * カウント数取得
  	 */	
	function getMasterCount($aMasterID) {
 
		$con = DatabaseAccess::getConnection();
		$sql = "select count(*) from " . $this->myTableName .
		       " where master_id = " . $aMasterID;
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return 0;
		}
		$row = mysql_fetch_array($query); 

		$count = $row[0];
		mysql_free_result($query);
		//カウント数を更新	
		$this->myCount = $count;
		return $count;
  	}
  
  	//指定したマスタのデータを取得	
  	function selectByMasterID($aMasterID) {
		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select " . $this->myColumnName . " from " . $this->myTableName . 
               " where master_id = " . $aMasterID .
               " order by " . $this->myOrderBy;
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			mysql_free_result($query);
			return null;
		}
		$idx = 0;
		$rtn = array();
		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = $this->createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;
  	}
	
	/**
	 * 指定したページ数から取得したいデータのみを取得
	 */
	function selectByMasterPage($aPageNum,$aMasterID) {

		//リクエストページを更新
		$this->myRequestPageNum = $aPageNum;

		//カウントを取得	
		$cnt = $this->getMasterCount($aMasterID);	
		$limit = ($aPageNum * $this->myLimit) - $this->myLimit;
		//指定したページが表示件数を超えた場合
		if ( $limit >= $cnt ) {
			return null;
		}

		//表示可能ページ数を設定する
		$this->myMaxPageNum = (int)($cnt / $this->myLimit);
		//ちょうど割れない場合	
		if ( ($cnt % $this->myLimit) > 0 ) {
			//１つページ数を加算する
			$this->myMaxPageNum = $this->myMaxPageNum + 1;
		}

		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select " . $this->myColumnName . " from " . $this->myTableName . 
               " where master_id = " . $aMasterID .
               " order by " . $this->myOrderBy . " limit " . $this->myLimit . " offset " . $limit;
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			mysql_free_result($query);
			return null;
		}
		$idx = 0;
		$rtn = array();
		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = $this->createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;
	}

	
	function getSelection($aID,$aMasterID,$aName = "masterdata_id",$aEmpty="") {

		//戻り値に名称を設定
		$rtn = '<select name="' . $aName . '">';

		$masterdata_tb = new masterdata_tb;
		//テンプレートを全件取得
		$mst_array = $masterdata_tb->selectByMasterID($aMasterID);
		//空白指定がある場合
		if ( $aEmpty != "" ) {
			$rtn = $rtn . '<option value="">' . $aEmpty . '</option>';
		}

		//テンプレート数回繰り返す	
		foreach ($mst_array as $elm) {
			$id   = $elm->getID();	
			$name = $elm->getName();	
			$selected = "";
			//同一IDだった場合
			if ($id == $aID ) {
				//選択対象にする
				$selected = " selected";
			}
			//データを作成
			$opt_val = '<option value="' . $id . '"' . $selected . '>' . $name . '</option>';
			//一覧に追加
			$rtn = $rtn . $opt_val;
		}
		//タグを閉じる
		$rtn = $rtn . '</select>';
		return $rtn;
	}
	
  	function getID() {
		return $this->myID;
	}

  	function getMasterID() {
		return $this->myMasterID;
	}

	function getName() {
		return $this->myName;
	}
	
	function getDetail() {
		return $this->myDetail;
	}
	
	function setID($aID) {
		$this->myID = $aID;
	}

	function setMasterID($aMasterID) {
		$this->myMasterID = $aMasterID;
	}

	function setName($aName) {
		$this->myName = $aName;
	}
	
	function setDetail($aDetail) {
		$this->myDetail = $aDetail;
	}
  } 
?>
