<?
/*****************************************************************************
 * ID   : $Id: install_exec.php,v 1.1 2007/03/16 14:05:52 secondarykey Exp $
 * Name : インストーラー実行ファイル
 * Specifications :
 * 　引数を利用して、各種実行を行う
 ****************************************************************************/
 //Ō̕񂪃XbV
function last_slash( $aSource ) {
  $cnt = strrpos($aSource,'/');
  $len = strlen($aSource) - 1;
  if ( $cnt == $len ) {
  
  	return true;
  }
  return false;
}
//fBNg̃t@Cׂč폜
function removeDirectoryFile($aDirectory) {

	$directry = dir($aDirectory);
	while ($entry = $directry->read()) {
		$path = $aDirectory.$entry;
		if (!is_dir($path)) {
			$fh=unlink($path);
		}
	}
	$directry->close();
}

function getSQLArray($aFileName) {

	$fp = fopen($aFileName, "r") ;
	$lineArray = array();
	while( !(feof($fp) ) ) {
		$buf = fgets($fp, 1024);
		$buf = chop($buf);
		$lineArray[] = $buf;
	}
	fclose($fp);

	$rtnArray = array();
	$sql = "";
	foreach ( $lineArray as $line ) {

		$idx = strpos($line,';');
		if ( $idx == "" ) $idx = -1;
		$sql = $sql . $line;
		if ( $idx >= 0 ) {
			$rtnArray[] = $sql;
			$sql = "";
		}
	}

	return $rtnArray;	
}
$id = 1;

//引数を解析する
if ( isset($_POST['id']) ) {
	$id = $_POST['id'];
}

//セッションを開始する　
session_start();
$_SESSION["KANBE_MSG"] = "";

switch ($id) {
	
  case 1:
	header("Location: install.php?id=2");
    break;
  case 2:
	$url = "";
	$path = "";
	$manage_url = "";
	$manage_path = "";
	if ( isset($_POST['url']) ) {
		$url = $_POST['url'];
	}
	if ( isset($_POST['path']) ) {
		$path = $_POST['path'];
	}
	if ( isset($_POST['manage_url']) ) {
		$manage_url = $_POST['manage_url'];
	}
	if ( isset($_POST['manage_path']) ) {
		$manage_path = $_POST['manage_path'];
	}

	//アプリケーションの設定と管理アプリケーションの設定
	$_SESSION["URL"] = $url;
	$_SESSION["LOCAL_PATH"] = $path;
	$_SESSION["MANAGE_URL"] = $manage_url;
	$_SESSION["MANAGE_LOCAL_PATH"] = $manage_path;

	//設定の確認	
	if ( $url == "" || $path == "" || $manage_url == "" || $manage_path == "" ) {
		$_SESSION["KANBE_MSG"] = "すべて入力が必須です。";
		header("Location: install.php?id=2");
		return;
	}

	//入力がすべてスラッシュで終わってるかを確認
	if ( last_slash($url) == false || last_slash($path) == false ||
	     last_slash($manage_url) == false || last_slash($manage_path) == false ) {
		$_SESSION["KANBE_MSG"] = '最後の文字はスラッシュ"/"です。';
		header("Location: install.php?id=2");
		return;
	}

	//パスが正しいかを確認
	$index_file = $path . "index.php";
	$manege_index_file = $manage_path . "index.php";
	if ( !file_exists($index_file) ) {
		$_SESSION["KANBE_MSG"] = '公開ページのローカルパスは展開したパスを設定してください';
		header("Location: install.php?id=2");
		return;
	}
	if ( !file_exists($manege_index_file) ) {
		$_SESSION["KANBE_MSG"] = '管理ページのローカルパスは展開したパスを設定してください';
		header("Location: install.php?id=2");
		return;
	}
	header("Location: install.php?id=3");
    break;

  case 3:

	$name = "";
	$desc = "";
	$rssnum = "";
	if ( isset($_POST['name']) ) {
		$name = $_POST['name'];
	}
	if ( isset($_POST['desc']) ) {
		$desc = $_POST['desc'];
	}
	if ( isset($_POST['rss']) ) {
		$rssnum = $_POST['rss'];
	}

	//アプリケーションの設定と管理アプリケーションの設定
	$_SESSION["SITE_NAME"] = $name;
	$_SESSION["SITE_DESCRIPTION"] = $desc;
	$_SESSION["SITE_RSS"] = $rssnum;

	header("Location: install.php?id=4");
    break;

  case 4:

	$server = "";
	$account = "";
	$password = "";
	$name = "";
	if ( isset($_POST['server']) ) {
		$server = $_POST['server'];
	}
	if ( isset($_POST['account']) ) {
		$account = $_POST['account'];
	}
	if ( isset($_POST['password']) ) {
		$password = $_POST['password'];
	}
	if ( isset($_POST['name']) ) {
		$name = $_POST['name'];
	}
	//セッション変数にデータベース情報を定義します
	$_SESSION["DB_SERVER_ADDRESS"]  = $server;
	$_SESSION["DB_SERVER_ACCOUNT"]  = $account;
	$_SESSION["DB_SERVER_PASSWORD"] = $password;
	$_SESSION["DB_SERVER_NAME"]     = $name;

	//入力確認
	if ( $server == "" || $account == "" || $name == "" ) {
		$_SESSION["KANBE_MSG"] = "パスワード以外は入力が必須です。";
		header("Location: install.php?id=4");
		return;
	}
	//データベース接続
	$db = mysql_pconnect($server,$account,$password) or die('<a href="./install.php?id=4">サーバまたはユーザが存在しません。<br>もしくはパスワードが間違っているかもしれません。</a>');
    //データベースの接続確認
    $flag = mysql_select_db($name, $db);
	if ( $flag == false ) {
		$_SESSION["KANBE_MSG"] = "データベース名が正しくありません。<br>";
		header("Location: install.php?id=4");
		return;
	}

	header("Location: install.php?id=5");
    break;

  case 5:
  
  	//スクリプトパスの取得
  	$installPath = $_SESSION["LOCAL_PATH"] . "install/";
  
  	$queryFile = $installPath . "sql/all.sql";	
  	$siteTemplateFile = $installPath . "template/site_1.tpl";	
  	$pageTemplateFile = $installPath . "template/page_1.tpl";	

	//クエリファイルの確認
	//テンプレートファイルの確認	
	if ( !file_exists($queryFile) ||
	      !file_exists($siteTemplateFile) ||
	      !file_exists($pageTemplateFile)) {
		$_SESSION["KANBE_MSG"] = "設定しているローカルパスが正しくありません。<br>";
		header("Location: install.php?id=5");
	}

	//テンプレート、画像、ファイル等をすべて削除
	$imgPath = $_SESSION["LOCAL_PATH"] . "images/";
	$resPath = $_SESSION["LOCAL_PATH"] . "res/";
	$tmpPath = $_SESSION["MANAGE_LOCAL_PATH"] . "templates/template/";
	$siteTmpPath = $tmpPath . "site/";
	$pageTmpPath = $tmpPath . "page/";

	//画像ディレクトリ削除
	removeDirectoryFile($imgPath);
	//リソースディレクトリ削除
	removeDirectoryFile($resPath);
	//サイトテンプレート削除
	removeDirectoryFile($siteTmpPath);
	//ページテンプレート削除
	removeDirectoryFile($pageTmpPath);
	
	$server   = $_SESSION["DB_SERVER_ADDRESS"];
	$account  = $_SESSION["DB_SERVER_ACCOUNT"];
	$password = $_SESSION["DB_SERVER_PASSWORD"];
	$name     = $_SESSION["DB_SERVER_NAME"];
	
	//クエリファイルからデータの登録
	$sqlArray = getSQLArray($queryFile);
	
	//データベース接続
	$db = mysql_pconnect($server,$account,$password) or die('<a href="./install.php?id=5">サーバまたはユーザが存在しません。<br>もしくはパスワードが間違っているかもしれません。</a>');
    //データベースの接続確認
    $flag = mysql_select_db($name, $db);

	//配列数回繰り返す	
	foreach ( $sqlArray as $sql ) {
		//SQLを実行
		$query = mysql_query($sql,$db);
	}

	//登録データからサイトデータをインサート
	$sql = "insert into config_tb " .
	       "(id,name,detail,rssnum,app_path,app_url,manage_path,manage_url,pop3_port)" .
		   "values (1," .
		   "'" . $_SESSION["SITE_NAME"] . "'," .
		   "'" . $_SESSION["SITE_DESCRIPTION"] . "'," .
		   $_SESSION["SITE_RSS"] . "," . 
		   "'" . $_SESSION["LOCAL_PATH"] . "'," .
		   "'" . $_SESSION["URL"] . "'," .
		   "'" . $_SESSION["MANAGE_LOCAL_PATH"] . "'," .
		   "'" . $_SESSION["MANAGE_URL"] . "'," .
		   "110)";

	$query = mysql_query($sql,$db);
	//ファイルの展開	
	copy($siteTemplateFile,$siteTmpPath . "1.tpl");
	copy($pageTemplateFile,$pageTmpPath . "1.tpl");

	//データベース接続子の更新	
	require_once('ApplicationObject.php');	
	$apply = new ApplicationObject();
	$apply->setDBServer($server);
	$apply->setDBUser($account);
	$apply->setDBPassword($password);
	$apply->setDBName($name);
	$apply->write($_SESSION["MANAGE_LOCAL_PATH"]);

	header("Location: install.php?id=6");
    break;

  default:
    break;
}
 ?>