<?php
/*****************************************************************************
 * ID   : $Id: ImageObject.php,v 1.1 2007/03/16 14:05:52 secondarykey Exp $
 * Name : 
 * Specifications :
 ****************************************************************************/
$gImageObject     = null;
$gImageReloadFlag = true;
class ImageObject
{

	//データベース値	
	var $myImageArray = null;

	// コンストラクタ
	function ImageObject() {
	}
	
	//インスタンスを取得	
	function getInstance() {
		
		global $gImageObject,$gImageReloadFlag;
		
		//生成されていない場合
		if ( $gImageObject == null ) {
			//生成する
			$gImageObject = new ImageObject();
		}

		//読み込み指定がある場合	
		if ( $gImageReloadFlag == true ) {
			$gImageObject->reload();
		}
		return $gImageObject;
	}

	/**
	 * リロード設定に変更する
	 */	
	function setReload() {
		global $gImageReloadFlag;
		$gImageReloadFlag = true;
	}
	
	/**
	 * データ作成
	 */
	function reload() {
		//全件検索
		$image_tb = new image_tb;
		$imageArray = $image_tb->select();
		
		$this->myImageArray = array();
		if ( $imageArray == null ) {
			return;
		}

		//配列を準備	
		foreach ( $imageArray as $elm ) {
			$id = $elm->getID();
			$this->myImageArray[$id] = $elm;
		}
	}	

	/**
	 * データ取得
	 */	
	function get($aID) {
	}	

	/**
	 * 画像タグ取得
	 */	
	function tag($aID) {
		//オブジェクトを取得	
		$imgTb = $this->myImageArray[$aID];
		//存在しない場合
		if ( $imgTb == null ) {
			return "";
		}
		//タグを取得	
		return $imgTb->getImageTag();
	}
	
	/**
	 * 画像名取得
	 */	
	function src($aID) {
		//オブジェクトを取得	
		$imgTb = $this->myImageArray[$aID];
		//存在しない場合
		if ( $imgTb == null ) {
			return "";
		}
		//タグを取得	
		return $imgTb->getImageSrc();
	}
}
?>
